import { AccumulatePass } from '../accumulatepass';
import { AntiAliasingKernel } from '../antialiasingkernel';
import { BlitPass } from '../blitpass';
import { Context } from '../context';
import { DefaultFramebuffer } from '../defaultframebuffer';
import { EventProvider } from '../eventhandler';
import { Framebuffer } from '../framebuffer';
import { NdcFillingTriangle } from '../ndcfillingtriangle';
import { Program } from '../program';
import { Renderbuffer } from '../renderbuffer';
import { Invalidate, Renderer } from '../renderer';
import { Texture2D } from '../texture2d';
import { TestNavigation } from './testnavigation';
declare namespace debug {
    class TestRenderer extends Renderer {
        protected _extensions: boolean;
        protected _program: Program;
        protected _ndcOffsetKernel: AntiAliasingKernel;
        protected _uNdcOffset: WebGLUniformLocation;
        protected _uFrameNumber: WebGLUniformLocation;
        protected _ndcTriangle: NdcFillingTriangle;
        protected _accumulate: AccumulatePass;
        protected _blit: BlitPass;
        protected _defaultFBO: DefaultFramebuffer;
        protected _colorRenderTexture: Texture2D;
        protected _depthRenderbuffer: Renderbuffer;
        protected _intermediateFBO: Framebuffer;
        protected _testNavigation: TestNavigation;
        protected onInitialize(context: Context, callback: Invalidate, eventProvider: EventProvider): boolean;
        protected onUninitialize(): void;
        protected onDiscarded(): void;
        protected onUpdate(): boolean;
        protected onPrepare(): void;
        protected onFrame(frameNumber: number): void;
        protected onSwap(): void;
    }
}
export = debug;
