import { vec2, vec3 } from 'gl-matrix';
import { CameraModifier } from './cameramodifier';
export declare class PinchZoomModifier extends CameraModifier {
    protected static readonly DEFAULT_SENSITIVITY = 2;
    protected _sensitivity: number;
    protected _initialDistance: number;
    protected _currentDistance: number;
    protected _translation: vec3;
    /**
     * Initiate a new panning at a specific event position.
     * @param point - Position of the current event to derive the magnitude for rotation from.
     */
    initiate(point1: vec2, point2: vec2): void;
    /**
     * Update the panning transform w.r.t. a specific event position.
     * @param point - Position of the current event to derive the magnitude for translation from.
     */
    process(point1: vec2, point2: vec2): void;
    /**
     * Actually applies the trackball rotation to the given camera.
     */
    update(): void;
}
